Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 451210 - PDF mode should use evince, not xpdf
Summary: PDF mode should use evince, not xpdf
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: emacs-auctex
Version: rawhide
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Jonathan Underwood
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-06-13 12:40 UTC by Matthew Saltzman
Modified: 2018-04-30 22:10 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)

Description Matthew Saltzman 2008-06-13 12:40:20 UTC
Description of problem:
In PDF mode, auctex displays formatted documents using xpdf by default.  Should
use evince by default instead.

Version-Release number of selected component (if applicable):
emacs-auctex-11.85-1.fc8.noarch

How reproducible:
Always

Steps to Reproduce:
1. Select Command -> TeXing options -> PDF mode from the menu.
2. LaTeX and View with C-c C-c commands
3.
  
Actual results:
Compiled document displays in xpdf window.

Expected results:
Compiled document displays in evince.

Additional info:

Comment 1 Rex Dieter 2008-06-13 13:18:42 UTC
Or potentially use xdg-open do use the system/user-prefered pdf app.

Comment 2 Matthew Saltzman 2008-06-13 13:29:46 UTC
(In reply to comment #1)
> Or potentially use xdg-open do use the system/user-prefered pdf app.

Yes, even better.  I didn't know how that worked, so wasn't sure if it could be
done easily here.



Comment 3 Jonathan Underwood 2008-06-13 13:37:39 UTC
Yes, good points. I'll get to this over the weekend (is a pretty trivial
change). Thansk for the report.

Comment 4 Matthew Saltzman 2008-07-06 23:20:50 UTC
Any progress on getting this pushed out?

Thanks!

Comment 5 Jonathan Underwood 2008-07-13 09:05:01 UTC
Hi Matthew,

I looked at this, and in the end, I can't convince myself that evince is ready
to replace xpdf for auctex useage. Specifically, evince doesn't support the
following functionality that xpdf has an auctex expects:

1) There's no way to say to evince "reload that file" from the command line. As
such, eavh View invocation from auctex will start a new evince session, rather
than using the existing one.

2) There's no way to tell evince to go to a specific page on the command line

3) No forward search capability exists in evince - if you use pdfsync you can
jump between the source tex file and the corresponding position in the pdf file.

So, alas, making the change you suggest to the default settings would cause
regressions for many users. I would love to be told I am wrong about these items
and that evince/xdg-open can deal with these needs!





Comment 6 Matthew Saltzman 2008-07-13 13:48:06 UTC
OK.  What's the best way to turn this into an Evince RFE?

BTW, with xdvi, there's no need to invoke auctex's View command, you just select
the xdvi window and it updates automatically.  That feature would make PDF-mode
auctex even better.

Comment 7 Jonathan Underwood 2008-07-14 18:48:29 UTC
Actually, automatically updating evince when a PDF file is updated has been a
long asked for request, see:

http://bugzilla.gnome.org/show_bug.cgi?id=304249

As regards replacing xdvi with evince, there are other issues with that. For
example: dvi documents don't contain any page size information - Auctex gets
around this by extracting the papersize argument from the input tex file, and
then passing a -papersize argument to xdvi. Alas, evince has no command line
argument to set the paper size. there are other functionalities missing in
evince's dvi mode as well, I don't recall them right now.

But yes, it would be great if evince provided all of the functionality of xdvi
and xpdf. xdg-open would need to expose that functionality as well.

Comment 8 Bug Zapper 2008-11-26 10:51:52 UTC
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 9 Bug Zapper 2009-11-18 12:34:53 UTC
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 10 Jonathan Underwood 2009-11-18 13:48:38 UTC
Moving this to rawhide, as it's still an aspiration.

Comment 11 Kevin Kofler 2010-01-28 05:56:23 UTC
What about Okular as the default?
re 1, Okular normally reloads automatically. It can also be forced through D-Bus.
re 2, qdbus `qdbus org.kde.okular-\*` /okular goToPage 12
but re 3, unfortunately there appears to be no support for forward search, just (poorly documented, use Shift+left click) support for inverse search (but this may be hardcoded to work only with Kile) :-(

Comment 12 Jonathan Underwood 2010-01-28 10:37:11 UTC
Actually, as far as I can tell, evince has the functionality that we need now, and it from what Kevin says Okular mostly does too, so following Rex's suggestion of using xdg-open is probably do-able at this point. I'll have a look into it.

Comment 13 Fedora Update System 2010-01-28 14:22:34 UTC
emacs-auctex-11.85-10.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/emacs-auctex-11.85-10.fc12

Comment 14 Jonathan Underwood 2010-01-28 14:25:41 UTC
OK, I've built new packages for F-12 and rawhide which now will use evince to view pdf files, and xdg-open to view html files.

Still to do:

1/ It would be better to use xdg-open to view pdf files. However, xdg-open doesn't have the command line options that evince or okular have, so this basically needs an enhancement to xdg-open to handle/communicate extra command line arguments

2/ Use evince (or better yet xdg-open) to view dvi files. This requires a way to pass the paper size to evince/okular/xdg-open via the command line.

Comment 15 Fedora Update System 2010-02-02 01:08:36 UTC
emacs-auctex-11.85-10.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 16 Phil V 2010-07-22 09:15:15 UTC
Does evince have forward search and reverse search capability?
How about the other concerns of Comment #5 ?

Comment 17 Jonathan Underwood 2010-07-22 14:44:07 UTC
(In reply to comment #16)
> Does evince have forward search and reverse search capability?
Yes (try it an see)

> How about the other concerns of Comment #5 ?    

Adressed.

upstream auctex has moved to using evince by default for PDF viewing anyway, and so the F-13 and rawhide packages are currently doing this anyway.

Leaving this bug open though, as longer term xdg-open would be preferable.

Comment 18 Phil V 2010-07-29 03:31:15 UTC
>> Does evince have forward search and reverse search capability?
>  Yes (try it an see)

How do you do reverse search with evince?

I've tried and not yet seen, but then again, I can't find any documentation of reverse search with evince, so I am not sure what to try.

Furthermore, forward search with evince only turns to the *top* of the page which contains the output of interest. It turns to the top of the page even if the output of interest is at the bottom of the page and *not visible* in the evince window.

In contrast, auctex does forward and reverse search very well with xdvi and source-specials. Please see http://xdvi.sourceforge.net/inverse-search.html
    *   A mouse click (Ctrl-Button1 by default) in the xdvi window can open an editor with the corresponding place in the (La)TeX source (also called `reverse search'), and
    *   xdvi can jump to (and visually highlight) a position in the DVI file that corresponds to a certain line number in the (La)TeX source file (`forward search'). 

Here's my attempt to use evince: 
(Set TeX-source-correlate-method to synctex. Restart emacs and set it to generate PDF. C-c C-c compiles a file, C-c C-v does a limited kind of forward search, turning to the top of the correct page but not moving to the correct position of the page. Also, not highlighting the correct position.

I've tried many combinations of mouse clicks in evince, with shift-option-control, but see no movement of emacs point in the source.

Comment 19 Jonathan Underwood 2010-07-29 14:59:47 UTC
(In reply to comment #18)
> >> Does evince have forward search and reverse search capability?
> >  Yes (try it an see)
> 
> How do you do reverse search with evince?
> 
> I've tried and not yet seen, but then again, I can't find any documentation of
> reverse search with evince, so I am not sure what to try.
> 
> Furthermore, forward search with evince only turns to the *top* of the page
> which contains the output of interest. It turns to the top of the page even if
> the output of interest is at the bottom of the page and *not visible* in the
> evince window.
> 

Oh right, you mean search correlated to the latex source - I thought you meant just searching for a given term in the evince window.

> In contrast, auctex does forward and reverse search very well with xdvi and
> source-specials. Please see http://xdvi.sourceforge.net/inverse-search.html
>     *   A mouse click (Ctrl-Button1 by default) in the xdvi window can open an
> editor with the corresponding place in the (La)TeX source (also called `reverse
> search'), and
>     *   xdvi can jump to (and visually highlight) a position in the DVI file
> that corresponds to a certain line number in the (La)TeX source file (`forward
> search'). 

Right. That as far as I know isn't currently possible with evince. My suggestion is that you should file an RFE on the evince upstream bugzilla asking for this functionality.

> 
> Here's my attempt to use evince: 
> (Set TeX-source-correlate-method to synctex. Restart emacs and set it to
> generate PDF. C-c C-c compiles a file, C-c C-v does a limited kind of forward
> search, turning to the top of the correct page but not moving to the correct
> position of the page. Also, not highlighting the correct position.
> 
> I've tried many combinations of mouse clicks in evince, with
> shift-option-control, but see no movement of emacs point in the source.    

I see there's some patches discussed here for synctex support in evince I haven't tried though:

http://www.mail-archive.com/auctex@gnu.org/msg03550.html

When I am back from travelling (in a couple of weeks), I will give those a try - if you can try them in the meantime, that would be very helpful.

Comment 20 Phil V 2010-07-29 22:56:34 UTC
> Right. That as far as I know 
> isn't currently possible with evince. My suggestion is that you should file an
> RFE on the evince upstream bugzilla asking for this functionality.

There is a Enhancement Request that was entered two years ago that is still considered "NEW" 
https://bugzilla.gnome.org/show_bug.cgi?id=543503

Seems there may be something in the works, but I don't know how to access nor apply it.

Comment 21 Matěj Cepl 2014-10-25 18:21:13 UTC
(In reply to Phil V from comment #20)
> There is a Enhancement Request that was entered two years ago that is still
> considered "NEW" 
> https://bugzilla.gnome.org/show_bug.cgi?id=543503

This has been closed (2010-07-09 10:15:43 CEST) and for the non-DBUS version of reverse search there is https://bugzilla.gnome.org/show_bug.cgi?id=647146 with some workarounds.


Note You need to log in before you can comment on or make changes to this bug.